﻿using System;
using System.Collections.Generic;

namespace UMK.WzorceOperacyjne
{
    //https://sourcemaking.com/design_patterns/observer/cpp/1

    interface IObserwator
    {
        void Aktualizuj(int parametr);
    }

    class Dzielenie : IObserwator
    {
        private int wartość = 0;
        private int dzielnik;

        public Dzielenie(int dzielnik)
        {
            this.dzielnik = dzielnik;
        }

        public void Aktualizuj(int dzielna)
        {
            wartość = dzielna / dzielnik;
            Console.WriteLine("{0} / {1} = {2}", dzielna, dzielnik, wartość);
        }
    }

    class Modulo : IObserwator
    {
        private int wartość = 0;
        private int dzielnik;

        public Modulo(int dzielnik)
        {
            this.dzielnik = dzielnik;
        }

        public void Aktualizuj(int dzielna)
        {
            wartość = dzielna % dzielnik;
            Console.WriteLine("{0} % {1} = {2}", dzielna, dzielnik, wartość);
        }
    }

    class WartośćZmienionaEventArgs : EventArgs
    {
        public int Wartość;
    }

    delegate void WartośćZmienionaEventHandler(object sender, WartośćZmienionaEventArgs e);

    class Podmiot
    {
        private int wartość;
        //private Dzielenie dzielenie; //obiekty, których stan zależy od zmieniającego się pola wartość
        //private Modulo modulo;
        //private List<IObserwator> obserwatorzy = new List<IObserwator>();
        public event WartośćZmienionaEventHandler WartośćZmieniona;

        private void powiadom() //onWartośćZmieniona
        {
            //dzielenie.Aktualizuj(wartość);
            //modulo.Aktualizuj(wartość);
            //foreach (IObserwator obserwator in obserwatorzy) obserwator.Aktualizuj(wartość);
            if (WartośćZmieniona != null)
                WartośćZmieniona(this, new WartośćZmienionaEventArgs() { Wartość = wartość });
        }

        /*
        public void PrzyłączObserwator(IObserwator obserwator)
        {
            if (!obserwatorzy.Contains(obserwator))
                obserwatorzy.Add(obserwator);
        }

        public void OdłączObserwatora(IObserwator obserwator)
        {
            if (obserwatorzy.Contains(obserwator))
                obserwatorzy.Remove(obserwator);
        }
        */

        public Podmiot()
        {
            wartość = 0;
            //dzielenie = new Dzielenie(3);
            //modulo = new Modulo(3);
        }

        public void ZmieńWartość(int nowaWartość)
        {
            wartość = nowaWartość;
            powiadom();
        }
    }
}